"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isRequired = void 0;
exports.property = property;
exports.unwrapOptional = unwrapOptional;
exports.wrapOptional = wrapOptional;
var _registry = /*#__PURE__*/require("@traversable/registry");
const isRequired = v => k => {
  if (!(0, _registry.has)('jsonSchema')(v[k])) return false;
  const jsonSchema = v[k].jsonSchema;
  if (!(jsonSchema && _registry.symbol.optional in jsonSchema)) return true;
  const optional = jsonSchema[_registry.symbol.optional];
  if (typeof optional !== 'number') return true;else return optional === 0;
};
exports.isRequired = isRequired;
function wrapOptional(x) {
  return (0, _registry.has)('jsonSchema', _registry.symbol.optional, u => typeof u === 'number')(x) ? x.jsonSchema[_registry.symbol.optional] + 1 : 1;
}
function unwrapOptional(x) {
  if ((0, _registry.has)(_registry.symbol.optional, u => typeof u === 'number')(x)) {
    const opt = x[_registry.symbol.optional];
    if (opt === 1) delete x[_registry.symbol.optional];else x[_registry.symbol.optional]--;
  }
  return x;
}
function property(required) {
  return (x, k) => {
    if (!(0, _registry.has)('jsonSchema')(x)) return x;else if (!required.includes(String(k))) return unwrapOptional(x.jsonSchema);else return x.jsonSchema;
  };
}
//# sourceMappingURL=properties.js.map