import { has, symbol } from '@traversable/registry';
export const isRequired = v => k => {
  if (!has('jsonSchema')(v[k])) return false;
  const jsonSchema = v[k].jsonSchema;
  if (!(jsonSchema && symbol.optional in jsonSchema)) return true;
  const optional = jsonSchema[symbol.optional];
  if (typeof optional !== 'number') return true;else return optional === 0;
};
export function wrapOptional(x) {
  return has('jsonSchema', symbol.optional, u => typeof u === 'number')(x) ? x.jsonSchema[symbol.optional] + 1 : 1;
}
export function unwrapOptional(x) {
  if (has(symbol.optional, u => typeof u === 'number')(x)) {
    const opt = x[symbol.optional];
    if (opt === 1) delete x[symbol.optional];else x[symbol.optional]--;
  }
  return x;
}
export function property(required) {
  return (x, k) => {
    if (!has('jsonSchema')(x)) return x;else if (!required.includes(String(k))) return unwrapOptional(x.jsonSchema);else return x.jsonSchema;
  };
}
//# sourceMappingURL=properties.js.map